Main Page | Alphabetical List | Data Structures | File List | Data Fields | Globals

# dmxsync.c File Reference

`#include "dmx.h"`
`#include "dmxsync.h"`
`#include "dmxstat.h"`
`#include "dmxlog.h"`
`#include <sys/time.h>`

## Functions
void | dmxSyncActivate (const char *interval)
void | dmxSyncInit (void)
void | dmxSync (DMXScreenInfo *dmxScreen, Bool now)

## Detailed Description

The DMX server code is written to call dmxSync() whenever an XSync() might be necessary. However, since XSync() requires a two way communication with the other X server, eliminating unnecessary XSync() calls is a key performance optimization. Support for this optimization is provided here. Statistics about XSync() calls and latency are gathered in #dmxstat.c.

During the initial conversion from calling XSync() immediately to the XSync() batching method implemented in this file, it was noted that, out of more than 300 x11perf tests, 8 tests became more than 100 times faster, with 68 more than 50X faster, 114 more than 10X faster, and 181 more than 2X faster.

## Function Documentation

void dmxSync | ( | DMXScreenInfo * | dmxScreen,
|  | Bool | now
| ) |

| Request an XSync() to the display used by dmxScreen. If now is TRUE, call XSync() immediately instead of waiting for the next XSync() batching point. Note that if XSync() batching was deselected with dmxSyncActivate() before dmxSyncInit() was called, then no XSync() batching is performed and this function always calles XSync() immediately. (Note that this function uses TimerSet but works correctly in the face of a server generation. See the source for details.) If dmxScreen is NULL, then all pending syncs will be flushed immediately.

void dmxSyncActivate | ( | const char * | interval | ) |

| Request the XSync() batching optimization with the specified interval (in mS). If the interval is 0, 100mS is used. If the interval is less than 0, then the XSync() batching optimization is not requested (e.g., so the -syncbatch -1 command line option can turn off the default 100mS XSync() batching). Note that the parameter to this routine is a string, since it will usually be called from ddxProcessArgument in #dmxinit.c

void dmxSyncInit | ( | void |  | ) |

| Initialize the XSync() batching optimization, but only if dmxSyncActivate was last called with a non-negative value.